// histogram
HistoGen histoR, histoG, histoB; 
int[] histoArrayR, histoArrayG, histoArrayB;
int maxXhisto, maxXhistoR, maxXhistoG, maxXhistoB;
// button
RectButton buttonR, buttonG, buttonB, buttonNxt;
boolean locked = false;

// source image
int imgMax = 5;
PImage[] img = new PImage[imgMax];
int imgCount = 0;
// destination image
PImage destinationRGB, destinationR, destinationG, destinationB; // Destination image

// handel pixel
int i;
color col;
int r,g,b,a;
float bright;
int pixelCount;

void setup() {
  size(500,330);
  
  pixelCount = width*height;
  
  // load all img
  for (i = 0; i< img.length; i++ ) {
    img[i] = loadImage( "data/" + i + ".jpg" );
  }
  
  // init histogramdata
  histoArrayR = new int[256];
  histoArrayG = new int[256];
  histoArrayB = new int[256];
  
  // init button
  buttonNxt = new RectButton(0, 0, 20, color(255,255,255,0), color(255,255,255,0));
  buttonR = new RectButton(0, 100, 20, color(255,0,0), color(200,0,0));
  buttonG = new RectButton(0, 150, 20, color(0,255,0), color(0,200,0));
  buttonB = new RectButton(0, 200, 20, color(0,0,255), color(0,0,200));
  
  // init new img
  destinationRGB = createImage(width, height, RGB);
  destinationRGB.loadPixels();
  destinationR = createImage(width, height, RGB);
  destinationR.loadPixels();
  destinationG = createImage(width, height, RGB);
  destinationG.loadPixels();
  destinationB = createImage(width, height, RGB);
  destinationB.loadPixels();
  
  loadImg();
}

void draw() {
  update(mouseX, mouseY);
  
  // display button
  buttonNxt.display();
  buttonR.display();
  buttonG.display();
  buttonB.display();
}

void update(int x, int y)
{
  if(locked == false) {
    buttonNxt.update();
    buttonR.update();
    buttonG.update();
    buttonB.update();
  } 
  else {
    locked = false;
  }

  if(mousePressed) {
    if(buttonNxt.pressed()) {
      loadImg();
      imgCount++;
    } else if(buttonR.pressed()) {
      destinationR.updatePixels();
      tint(255, 0, 0, 50); 
      image(destinationR,0,0);      
      pushMatrix();
        translate(0,height);
        scale(1.0,-1);
        histoR.draw();
      popMatrix();
    } 
    else if(buttonG.pressed()) {
      destinationG.updatePixels();
      tint(0, 255, 0, 50);
      image(destinationG,0,0);      
      pushMatrix();
        translate(0,height);
        scale(1.0,-1);
        histoG.draw();
      popMatrix();
    }
    else if(buttonB.pressed()) {
      destinationB.updatePixels();
      tint(0, 0, 255, 50);
      image(destinationB,0,0);
      pushMatrix();
        translate(0,height);
        scale(1.0,-1);
        histoB.draw();
      popMatrix();
    }
  }
  else {
    destinationRGB.updatePixels();
    tint(255, 255, 255, 255);
    image(destinationRGB,0,0);
    pushMatrix();
      translate(0,height);
      scale(1.0,-1);
      histoR.draw();
      histoG.draw();
      histoB.draw();
    popMatrix();
  }
}

void loadImg() {
  if(imgCount >= imgMax) {
    imgCount = 0;
  }
  
  // init/reset histogramdata
  for(i=0; i<256; i++) {
    histoArrayR[i] = 0;
    histoArrayG[i] = 0;
    histoArrayB[i] = 0;
  }
  
  // init histogram
  histoR = new HistoGen();
  histoG = new HistoGen();
  histoB = new HistoGen();
  
  // get image data
  img[imgCount].loadPixels();
  for(int j=0; j<pixelCount; j++) {
    
    col = img[imgCount].pixels[j];
    r = (col >> 16) & 0xFF;
    g = (col >> 8) & 0xFF;
    b = col & 0xFF;
    
    destinationRGB.pixels[j] = color(r,g,b);
    destinationR.pixels[j] = color(r,0,0);
    destinationG.pixels[j] = color(0,g,0);
    destinationB.pixels[j] = color(0,0,b);
    
    histoArrayR[int(r)]++;
    histoArrayG[int(g)]++;
    histoArrayB[int(b)]++;
  }
  
  // find max X
  // hack - cut the 0 peak
  histoArrayR[0] = 0;
  histoArrayG[0] = 0;
  histoArrayB[0] = 0;
  
  maxXhistoR = max(histoArrayR);
  maxXhistoG = max(histoArrayG);
  maxXhistoB = max(histoArrayB);
  maxXhisto = max(maxXhistoR,maxXhistoG,maxXhistoB);
  
  // build histogram
  for(i=0; i<256; i++) {
    histoR.add(new Balken(i*2,0,1,histoArrayR[i]*height/maxXhisto,color(i,0,0)));
    histoG.add(new Balken(i*2,0,1,histoArrayG[i]*height/maxXhisto,color(0,i,0)));
    histoB.add(new Balken(i*2,0,1,histoArrayB[i]*height/maxXhisto,color(0,0,i)));
  }
}


